From 3532c45dc451d2bb7d88a33a554a86422828c9aa Mon Sep 17 00:00:00 2001
From: Camelia Groza <camelia.groza@nxp.com>
Date: Thu, 13 Jul 2017 17:26:02 +0300
Subject: [PATCH] sdk_dpaa: ls1043a errata: resplit the skb after copy

Signed-off-by: Camelia Groza <camelia.groza@nxp.com>
---
 drivers/net/ethernet/freescale/sdk_dpaa/dpaa_eth_sg.c | 5 +++++
 1 file changed, 5 insertions(+)

--- a/drivers/net/ethernet/freescale/sdk_dpaa/dpaa_eth_sg.c
+++ b/drivers/net/ethernet/freescale/sdk_dpaa/dpaa_eth_sg.c
@@ -1016,6 +1016,7 @@ int __hot dpa_tx_extended(struct sk_buff
 #endif /* CONFIG_FSL_DPAA_TS */
 
 #ifndef CONFIG_PPC
+resplit_4k:
 	if (unlikely(dpaa_errata_a010022)) {
 		skb = split_skb_at_4k_boundaries(skb);
 		if (!skb)
@@ -1062,6 +1063,10 @@ int __hot dpa_tx_extended(struct sk_buff
 			struct sk_buff *nskb = skb_copy(skb, GFP_ATOMIC);
 			kfree_skb(skb);
 			skb = nskb;
+#ifndef CONFIG_PPC
+			if (unlikely(dpaa_errata_a010022))
+				goto resplit_4k;
+#endif
 			/* skb_copy() has now linearized the skbuff. */
 		} else if (unlikely(nonlinear)) {
 			/* We are here because the egress skb contains
